** example1.prg ----------------------------------------------------
*
* VFS6: compile
*  FlagShip -stat -io=b example1.prg -oexample1
*
* FS4.4x: compile
*  FlagShip example1.prg -oexample1
*    and preferrably "cp /etc/FSconfig ." and modify ./FSconfig
*    for static linking. 
* See details in fs4web.html

#define DBFNAME "example1"    /* modify upon request */
#define DBFPATH "/cgi-bin"    /* modify upon request */

#ifdef FlagShip5
# define USE_WEB_FUNCTIONS    /* in VFS6, use comfortable Web functions */
#endif

   parameter cCust                      // optional command-line parameter
   field custID, name, address          // used database fields
   local aWebData, iPos

   /* get the HTML form data, if any
    */
   if empty(cCust)                      // w/o command-line parameter:
#ifdef USE_WEB_FUNCTIONS
      aWebData := WebGetFormData()      // get form data
      iPos := Ascan(aWebData, {|x| upper(x[1]) == "CUSTOMERID"} )
      if iPos > 0 
         cCust := aWebData[iPos,2]      // data of CUSTOMERID tag
      endif
#else
      cCust := getenv("QUERY_STRING")   // use simple GET method
      if !empty(cCust) .and. ("=" $ cCust)
         cCust := trim(substr(cCust, rat("=",cCust)+1))
      endif
#endif
   endif
   nCust := val(cCust)

   /* write HTML reply prefix
    */
#ifdef USE_WEB_FUNCTIONS
   cWebHeaderTitle := "Test Web Page"   // title
   WebHtmlBegin()                       // create HTML prefix
#else
   ?? "Content-Type: text/html"
   ?
   ? "<HTML>"
   ? "<HEAD><TITLE>Test Web Page</TITLE></HEAD>"
   ? "<BODY>"       // or: ? '<BODY BCOLOR="#FFFFFF">'
#endif

   /* Now, we access the database and search it for 
    * data specified by the given customer-ID,
    * and write the HTML reply body text
    */
   if !file(DBFNAME + ".dbf")
      set default to (DBFPATH)
   endif
   if !file(DBFNAME + ".dbf") .or. !file(DBFNAME + ".idx")
      ? "<P>*** sorry, database not available or wrong path **"
   elseif nCust == 0
      ? "<P>*** sorry, no data without customer ID **"
   else
      use (DBFNAME) index (DBFNAME) shared
      ok := used() .and. !neterr()
      ? "Listing the data for customer no. " + ltrim(str(nCust))
      if !ok
         ? "<P>*** error, cannot open database or index"
      else
         seek nCust
         if !found()
            ? "<P>*** sorry, no data available for this cust no."
         else
            ? "<P><TT>"
            while !eof() .and. custID == nCust
               ? custID, name, trim(address), "<BR>"
               skip
            enddo
            ?? "</TT>"
         endif
      endif
   endif
   ? "<P>"

   /* write HTML reply postfix
    */
#ifdef USE_WEB_FUNCTIONS
   WebHtmlEnd()                // write HTML postfix
#else
   ? "</BODY>"
   ? "</HTML>"
#endif
   ?
   quit

/* disable curses, disable start-up messages if any
 */
FUNCTION ProgramInit()       // required for  
   CALL fgsUse4html          // FS 4.4x
   RETURN NIL                // see fsman sect SYS.2.9

FUNCTION CursesInit()	     // required for FS 4.4x
   RETURN NIL

** eof example1.prg -----------------------------------------------

